/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package PaqueteJuego;

import java.util.*;
import java.util.Observable;
import java.util.Arrays;
/**
 *
 * @author root
 */
public class Partida extends Observable {
    private static int Seleccionar_Territorio=0;
    private static int Ubicar_Tropas=1;
    private static int Reforzar=2;
    private static int Atacar=3;
    private static int Rearmar=4;
    
    private static int Ejercitos_2_Jugadores=28;
    private static int Ejercitos_3_Jugadores=73;
    private static int Ejercitos_4_Jugadores=61;
    private static int Ejercitos_5_Jugadores=24;
    private static int Ejercitos_6_Jugadores=11;

    private static int Continente1=3;
    private static int Continente2=2;
    private static int Continente3=7;
    private static int Continente4=5;
    private static int Continente5=5;
    private static int Continente6=2;
    
    private int TotalTurnos;
    private int TipoPartida;
    private int TurnoActual=Seleccionar_Territorio;
    private boolean SeleccionAleatoria;
    private boolean DarCarta;
    private Jugador JugadorTurno;
    private Territorio Atacante;
    private Territorio Defensor;
    private Territorio TerritorioA;
    private Territorio TerritorioB;

    private ArrayList<Territorio> Territorios;
    private ArrayList<Jugador> Jugadores;
    private ArrayList<Carta> Cartas;

    
    /**
     * Constructor Partida
     * @param T Lista de territorios
     * @param J Lista de Jugadores
     * @param C Lista de Cartas
     * @param TT Turnos Totales
     * @param SA Seleccion Aleatoria
     */
    public Partida(ArrayList<Territorio> T,ArrayList<Jugador> J,ArrayList<Carta> C,int TT,boolean SA,int TP){
        setJugadores(J);
        setTerritorios(T);
        setCartas(C);
        setTotalTurnos(TT);
        setTipoPartida(TP);
        setJugadorTurno(getJugadores().get(0));
        setSeleccionAleatoria(SA);
        AsignaEjercitosIniciales();
    }
    
    //Devuelve variable
    /**
     *
     * @return
     */
    public ArrayList<Territorio> getTerritorios() {
        return this.Territorios;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setTerritorios(ArrayList<Territorio> val) {
        this.Territorios=val;
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public ArrayList<Jugador> getJugadores() {
        return this.Jugadores;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setJugadores(ArrayList<Jugador> val) {
        this.Jugadores=val;
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public ArrayList<Carta> getCartas() {
        return this.Cartas;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setCartas(ArrayList<Carta> val) {
        this.Cartas=val;
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public int getTotalTurnos() {
        return this.TotalTurnos;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setTotalTurnos(int val) {
        this.TotalTurnos=val;
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public int getTurnoActual() {
        return this.TurnoActual;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setTurnoActual(int val) {
        this.TurnoActual=val;
        
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public Jugador getJugadorTurno() {
        return this.JugadorTurno;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setJugadorTurno(Jugador val) {
        this.JugadorTurno=val;
         //Avisa a la ventana para que actualice los datos
        setChanged();
        notifyObservers(1);
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setAtacante(Territorio val) {
        this.Atacante=val;
        //Avisa a la ventana para que actualice los datos
        setChanged();
        notifyObservers(1);
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public Territorio getAtacante() {
        return this.Atacante;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setDefensor(Territorio val) {
        this.Defensor=val;
        //Avisa a la ventana para que actualice los datos
        setChanged();
        notifyObservers(1);
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public Territorio getDefensor() {
        return this.Defensor;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setTerritorioA(Territorio val) {
        this.TerritorioA=val;
        //Avisa a la ventana para que actualice los datos
        setChanged();
        notifyObservers(1);
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public Territorio getTerritorioA() {
        return this.TerritorioA;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setTerritorioB(Territorio val) {
        this.TerritorioB=val;
        //Avisa a la ventana para que actualice los datos
        setChanged();
        notifyObservers(1);
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public Territorio getTerritorioB() {
        return this.TerritorioB;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setSeleccionAleatoria(boolean val) {
        this.SeleccionAleatoria=val;
    }

    //Devuelve variable
    /**
     *
     * @return
     */
    public boolean getSeleccionAleatoria() {
        return this.SeleccionAleatoria;
    }

    //Asigna un valor a variable 
    /**
     *
     * @param val
     */
    public void setDarCarta(boolean val) {
        this.DarCarta=val;
    }

     public int getTipoPartida() {
        return this.TipoPartida;
    }

    //Asigna un valor a variable
    /**
     *
     * @param val
     */
    public void setTipoPartida(int val) {
        this.TipoPartida=val;
    }
    //Devuelve variable
    /**
     *
     * @return
     */
    public boolean getDarCarta() {
        return this.DarCarta;
    }

    //Avanza el Turno al siguiente Jugador
    private void SiguienteJugador(){
        int Indice=getJugadores().indexOf(getJugadorTurno());

        if(Indice==getJugadores().size()-1){
            setJugadorTurno(getJugadores().get(0));
            if(getTurnoActual()==Reforzar){
                setTotalTurnos(getTotalTurnos()-1);
            }

        }else{
            setJugadorTurno(getJugadores().get(Indice+1));
            
        }
       
    }

    //Devuelve verdad si todos los territorios tienen dueño
    private boolean TodosTerritoriosAsignados(){
        Iterator<Territorio> Te=getTerritorios().iterator();
        boolean R=true;

        while(Te.hasNext()){
            Territorio T=Te.next();
            if(T.getPropietario()==null){
                R=false;
            }
        }
        return R;
    }

    //Devuelve verdad si todos los jugadores han asignado a sus ejercitos al comiezo del juego
    private boolean TodosEjercitosAsignados(){
        Iterator<Jugador> Ju=getJugadores().iterator();
        boolean R=true;

        while(Ju.hasNext()){
           Jugador J=Ju.next();
            if(J.getEjercitos()>0){
                R=false;
            }
        }
        return R;
    }

    //Devuelve un Territorio sin propietario de la lista de Territorios
    private Territorio DameTerritorioVacio(){
     Territorio Te=null;
     Iterator<Territorio> I=getTerritorios().iterator();
     ArrayList<Territorio> T=new ArrayList<Territorio>();

     while(I.hasNext()){
        Te=I.next();
        if(Te.getPropietario()==null){
            T.add(Te);
        }
     }

     java.util.Random X=new java.util.Random();
     Te=T.get(X.nextInt(T.size()));
     
     return Te;
    }

    //Asigna el territorio seleccionado al jugador
    /**
     *
     * @param Te
     * @param Ju
     */
    public void AsignaTerritorio(Territorio Te,Jugador Ju){
            int Indice=getTerritorios().indexOf(Te);
            
            getTerritorios().get(Indice).setPropietario(Ju);
            getTerritorios().get(Indice).setEjercitos(getTerritorios().get(Indice).getEjercitos()+1);
            Ju.setEjercitos(Ju.getEjercitos()-1);
            
            
           
            //Avisa a la ventana para que actualice los datos
            setChanged();
            notifyObservers(1);
    }

    //Devuelve verdad si el territorio T2 es vecino de T1
    /**
     *
     * @param T1
     * @param T2
     * @return
     */
    public boolean TerritoriosVecinos(Territorio T1,Territorio T2){
        boolean Res=false;
        Iterator I=T1.getTerritoriosVecinos().iterator();

        while(I.hasNext()){
            int P=Integer.valueOf(I.next().toString());
            if(getTerritorios().get(P-1)==T2){
                Res=true;
            }
        }
        return Res;

    }

    //Devuelve verdad si existe el jugador neutral
    /**
     *
     * @return
     */
    public boolean ExisteJugadorNeutral(){
        boolean R=false;
        Iterator<Jugador> Ju=getJugadores().iterator();
        while(Ju.hasNext()){
            Jugador Jug=Ju.next();
            if(Jug.getTipo()==2){
                R=true;
            }
        }
        return R;
    }
    
    //Inicializa el numero de ejercitos iniciales dependiendo del numero de jugadores
    private void AsignaEjercitosIniciales(){
        int Asignar=0;
        int TotalJugadores;

        if(ExisteJugadorNeutral()){
            TotalJugadores=2;
        }else{
            TotalJugadores=getJugadores().size();
        }
        switch (TotalJugadores){
            case 2: Asignar=Ejercitos_2_Jugadores;
                    break;
            case 3: Asignar=Ejercitos_3_Jugadores;
                    break;
            case 4: Asignar=Ejercitos_4_Jugadores;
                    break;
            case 5: Asignar=Ejercitos_5_Jugadores;
                    break;
            case 6: Asignar=Ejercitos_6_Jugadores;
                    break;
        }
        
        Iterator<Jugador> Ju=getJugadores().iterator();
        while(Ju.hasNext()){
            Jugador Jug=Ju.next();
            Jug.setEjercitos(Asignar);
        }
    }

    //Obtiene el total de ejercitos que corresponde a un jugador por territorios poseidos y continentes poseidos
    private void SumaEjercitosConseguidos(){
      
        Iterator<Jugador> Ju=getJugadores().iterator();
        while(Ju.hasNext()){
            Jugador Jug=Ju.next();
            int Ejercitos_Por_Territorios=EjercitosPorTerritoriosPoseidos(Jug);
            int Ejercitos_Por_Continentes=EjercitosPorContinentesPoseidos(Jug);

            Jug.setEjercitos(Ejercitos_Por_Territorios+Ejercitos_Por_Continentes);
        }

    }

    //Devuelve el total de ejercitos por territorio
    private int EjercitosPorTerritoriosPoseidos(Jugador Ju){
        int Total=0;
        int R=0;

        Iterator<Territorio> Te=getTerritorios().iterator();
        while(Te.hasNext()){
           Territorio T=Te.next();
           if(T.getPropietario()==Ju){
               Total=Total+1;
           }
        }

        if(Total<12){
            R=3;
        }else{
            R=Total/3;
        }

        return R;
    }

    //Devuelve el total de ejercitos por Continentes
    private int EjercitosPorContinentesPoseidos(Jugador Ju){
        int R=0,C=0;
       
        for(C=0;C<6;C++){
            boolean Posee=true;
            Iterator<Territorio> Te=getTerritorios().iterator();

            while(Te.hasNext()){
                Territorio T=Te.next();
                if(T.getContinente()==C){
                    if(T.getPropietario()!=Ju){
                        Posee=false;
                    }
                }
            }

            if(Posee){
                switch (C){
                    case 0: R=R+Continente1;
                            break;
                    case 1: R=R+Continente2;
                            break;
                    case 2: R=R+Continente3;
                            break;
                    case 3: R=R+Continente4;
                            break;
                    case 4: R=R+Continente5;
                            break;
                    case 5: R=R+Continente6;
                            break;

                }

            }
        }

        return R;
    }

    //Asigna un ejercito a un territorio 
    /**
     *
     * @param Te
     * @param Ju
     */
    public void AsignaEjercito(Territorio Te,Jugador Ju){
            int Indice=getTerritorios().indexOf(Te);

           if(Ju.getEjercitos()>0){
                getTerritorios().get(Indice).setEjercitos(getTerritorios().get(Indice).getEjercitos()+1);
                Ju.setEjercitos(Ju.getEjercitos()-1);
           }
           CompruebaTurno();
           //Avisa a la ventana para que actualice los datos
           setChanged();
           notifyObservers(1);
    }

    //Funcion encargada de Atacar, en la que se tiran los dados y se actualiza el resultado,devuelve el valor de los dados
    /**
     *
     * @return
     */
    public ArrayList Atacar(){
        ArrayList Res=new ArrayList();

        int[] DA=new int[3];
        int[] DD=new int[2];

        if((getAtacante()!=null)&&(getDefensor()!=null)&&(getAtacante().getEjercitos()>1)&&(getDefensor().getEjercitos()>0)){

            //Tiran los dados en funcion de los ejercitos que posean en los territorios
            if(getDefensor().getEjercitos()>=2){
               DD[0]=getDefensor().getPropietario().getDado().GeneraValor();
               DD[1]=getDefensor().getPropietario().getDado().GeneraValor();
               java.util.Arrays.sort(DD);
            }else{
               DD[0]=getDefensor().getPropietario().getDado().GeneraValor();
               DD[1]=0;
               java.util.Arrays.sort(DD);
            }

            if(getAtacante().getEjercitos()>=4){
                DA[0]=(getAtacante().getPropietario().getDado().GeneraValor());
                DA[1]=(getAtacante().getPropietario().getDado().GeneraValor());
                DA[2]=(getAtacante().getPropietario().getDado().GeneraValor());
                java.util.Arrays.sort(DA);
            }else if(getAtacante().getEjercitos()==3){
                DA[0]=(getAtacante().getPropietario().getDado().GeneraValor());
                DA[1]=(getAtacante().getPropietario().getDado().GeneraValor());
                DA[2]=0;
                java.util.Arrays.sort(DA);
            }else if(getAtacante().getEjercitos()==2){
                DA[0]=(getAtacante().getPropietario().getDado().GeneraValor());
                DA[1]=0;
                DA[2]=0;
                java.util.Arrays.sort(DA);
            }


            if(DD[0]==0){
                if(DD[1]<DA[2]){
                        getDefensor().setEjercitos(getDefensor().getEjercitos()-1);
                }else{
                        getAtacante().setEjercitos(getAtacante().getEjercitos()-1);
                }
            }else{
                if(DD[1]<DA[2]){
                        getDefensor().setEjercitos(getDefensor().getEjercitos()-1);
                }else{
                        getAtacante().setEjercitos(getAtacante().getEjercitos()-1);
                }
                if(DA[1]>0){
                    if(DD[0]<DA[1]){
                        getDefensor().setEjercitos(getDefensor().getEjercitos()-1);
                    }else{
                        getAtacante().setEjercitos(getAtacante().getEjercitos()-1);
                    }
                }

            }


        }
        if(getDefensor().getEjercitos()==0){
            getDefensor().setPropietario(getAtacante().getPropietario());
            getAtacante().setEjercitos(getAtacante().getEjercitos()-1);
            getDefensor().setEjercitos(getDefensor().getEjercitos()+1);
            if(getDefensor().getCapital()){
                DameCartaCapital(getDefensor()).setPropietario(getAtacante().getPropietario());
            }
            setDarCarta(true);
        }
        Res.add(DA[0]);
        Res.add(DA[1]);
        Res.add(DA[2]);
        Res.add(DD[0]);
        Res.add(DD[1]);

       
        return Res;
        
    }

    //Devuelve la lista de cartas del jugador que se le pasa como parametro
    /**
     *
     * @param J
     * @return
     */
    public ArrayList<Carta> CartasPoseidas(Jugador J){
        ArrayList<Carta> C=new ArrayList<Carta>();
        Iterator<Carta> T=getCartas().iterator();

        while (T.hasNext()){
            Carta c=T.next();
            if((c.getPropietario()==J)){
                if(getTipoPartida()==1){
                    if(!EsCartaCapital(c)){
                        C.add(c);
                    }
                }else{
                    C.add(c);
                }
            }
        }
        return C;
    }

     //Devuelve la lista de capitales del jugador que se le pasa como parametro
    /**
     *
     * @param J
     * @return
     */
    public ArrayList<Carta> CapitalesPoseidas(Jugador J){
        ArrayList<Carta> C=new ArrayList<Carta>();
        Iterator<Carta> T=getCartas().iterator();

        while (T.hasNext()){
            Carta c=T.next();
            if((c.getPropietario()==J)){
               if(EsCartaCapital(c)){
                        C.add(c);
                    }
               
            }
        }
        return C;
    }


    /*El jugador J obtiene una carta*/
    private void AsignaCarta(Jugador J){
        Iterator<Carta> I=getCartas().iterator();
        int Indice=0;
        ArrayList<java.lang.Integer> Libres=new ArrayList<java.lang.Integer>();

        while(I.hasNext()){
            Carta C=I.next();
            if(C.getPropietario()==null){
                Libres.add(Indice);
            }
            Indice=Indice+1;
        }
        if(Libres.size()>0){
            java.util.Random R=new java.util.Random();
            getCartas().get(Libres.get(R.nextInt(Libres.size()))).setPropietario(J);
        }
    }

    /*El Jugador J cambia sus cartas por ejercitos*/
    /**
     *
     * @param J
     * @param C
     */
    public void CambiarCartas(Jugador J,ArrayList<Carta> C){
        int Tipo1,Tipo2,Tipo3;
        Tipo1=C.get(0).getTipoEjercito();
        Tipo2=C.get(1).getTipoEjercito();
        Tipo3=C.get(2).getTipoEjercito();

        //Tres cartas iguales
        if((Tipo1==Tipo2)&&(Tipo2==Tipo3)){
            J.setEjercitos(J.getEjercitos()+J.getEjercitosPorCartas());
            J.ActualizaEjercitosPorCartas();
            C.get(0).setPropietario(null);
            C.get(1).setPropietario(null);
            C.get(2).setPropietario(null);
        }

        //Tres cartas distintas
        if((Tipo1!=Tipo2)&&(Tipo2!=Tipo3)&&(Tipo1!=Tipo3)&&(Tipo1!=4)&&(Tipo2!=4)&&(Tipo3!=4)){
            J.setEjercitos(J.getEjercitos()+J.getEjercitosPorCartas());
            J.ActualizaEjercitosPorCartas();
            C.get(0).setPropietario(null);
            C.get(1).setPropietario(null);
            C.get(2).setPropietario(null);
        }

        //Dos cartas iguales y un comodin
        if((Tipo1==Tipo2)&&(Tipo2!=Tipo3)&&(Tipo3==4)){
            J.setEjercitos(J.getEjercitos()+J.getEjercitosPorCartas());
            J.ActualizaEjercitosPorCartas();
            C.get(0).setPropietario(null);
            C.get(1).setPropietario(null);
            C.get(2).setPropietario(null);
        }
        if((Tipo1==Tipo3)&&(Tipo2!=Tipo3)&&(Tipo2==4)){
            J.setEjercitos(J.getEjercitos()+J.getEjercitosPorCartas());
            J.ActualizaEjercitosPorCartas();
            C.get(0).setPropietario(null);
            C.get(1).setPropietario(null);
            C.get(2).setPropietario(null);
        }
        if((Tipo2==Tipo3)&&(Tipo2!=Tipo1)&&(Tipo1==4)){
            J.setEjercitos(J.getEjercitos()+J.getEjercitosPorCartas());
            J.ActualizaEjercitosPorCartas();
            C.get(0).setPropietario(null);
            C.get(1).setPropietario(null);
            C.get(2).setPropietario(null);
        }
       
        //Avisa a la ventana para que actualice los datos
        setChanged();
        notifyObservers(1);
    }

    //Devuelve el jugador con mas territorios
    private Jugador JugadorConMasTerritorios(){
        Jugador J=null;
        Jugador JM=null;
        int R=0;
        Iterator<Jugador> I=getJugadores().iterator();

        while(I.hasNext()){
            J=I.next();
            int Total=0;
           

            if(J.getTipo()!=3){
            Iterator<Territorio> Te=getTerritorios().iterator();
            while(Te.hasNext()){
                Territorio T=Te.next();
                if(T.getPropietario()==J){
                    Total=Total+1;
                }
            }
            if(R<Total){
                JM=J;
                R=Total;
            }
            }
        }

        return JM;
    }

    //Devuelve al jugador que ha conseguido mas territorios
    /**
     *
     * @return
     */
    public Jugador DameJugadorGanador(){
       Jugador J=null;
       Iterator<Jugador> I=getJugadores().iterator();
       while(I.hasNext()){
        J=I.next();
        if(PoseeTodosTerritorios(J)){
            break;
        }else{
            J=null;
        }
       }

       if(J!=null){
             return J;
       }else{
             return JugadorConMasTerritorios();
       }
      
   }

    //Devuelve verdad si el jugador posee todos los territorios
    private boolean PoseeTodosTerritorios(Jugador Ju){
        boolean Res=true;
        Iterator<Territorio> I=getTerritorios().iterator();
        while(I.hasNext()){
            Territorio T=I.next();
            if((T.getPropietario()!=null)&&(T.getPropietario()!=Ju)&&(T.getPropietario().getTipo()!=3)){
                Res=false;
            }
        }
        return Res;
    }

     //Devuelve verdad si el jugador posee todos los territorios
    private boolean PoseeTodasCapitales(Jugador Ju){
        boolean Res=true;
        int To=0;
        Iterator<Territorio> I=getTerritorios().iterator();
        while(I.hasNext()){
            Territorio T=I.next();
            if((T.getPropietario()!=null)&&(T.getPropietario()==Ju)&&(T.getCapital())){
                To=To+1;
            }
        }
        if(getJugadores().size()<5){
            if(To<2){
                Res=false;
            }
        }else{
             if(To<3){
                Res=false;
            }
        }
        return Res;
    }

    //Comprueba el estado de la partida
    private int GestionFinPartida(int Tipo){
        if(getTipoPartida()==0){
        //Si se acaban los turnos o se pulsa el boton de terminar se finaliza inmediatamente
        if((getTotalTurnos()<0)||(Tipo==1)){
           return 2;
        }else{
            //Sino se comprueba si se poseen todos los territorios
            Jugador J=null;
            Iterator<Jugador> I=getJugadores().iterator();
            while(I.hasNext()){
               J=I.next();
               if(PoseeTodosTerritorios(J)){
                   break;
               }else{
                   J=null;
               }
            }

            if(J!=null){
                return 2;
            }else{
                return 1;
            }
        }
        }else{
            //Si se acaban los turnos o se pulsa el boton de terminar se finaliza inmediatamente
            if((getTotalTurnos()<0)||(Tipo==1)){
                return 2;
            }else{
            //Sino se comprueba si se poseen todos los territorios
            Jugador J=null;
            Iterator<Jugador> I=getJugadores().iterator();
            while(I.hasNext()){
               J=I.next();
               if(PoseeTodasCapitales(J)){
                   break;
               }else{
                   J=null;
               }
            }

            if(J!=null){
                return 2;
            }else{
                return 1;
            }
        }
    }
    }
    private boolean EsCartaCapital(Carta C){
        boolean Res=false;
        Iterator<Territorio> I=getTerritorios().iterator();
        while(I.hasNext()){
            Territorio T=I.next();
            if(T.getNombre().equals(C.getNombre())){
                if(T.getCapital()){
                    Res=true;
                }
            }
        }
        return Res;
    }

    //Devuelve la carta correspondiente al territorio Te
    private Carta DameCartaCapital(Territorio Te){
        Carta Res=null;
        Iterator<Carta> I=getCartas().iterator();
        while(I.hasNext()){
            Carta C=I.next();
            if(C.getNombre().equals(Te.getNombre())){
                Res=C;
            }
        }
        return Res;
    }

    //Asigna 1 capital por jugadores
    private void AsignaCapitales(){
        Iterator<Jugador> J=getJugadores().iterator();
        while(J.hasNext()){
            Jugador Jug=J.next();
            ArrayList<Territorio> R=new ArrayList<Territorio>();
            Iterator<Territorio> T=getTerritorios().iterator();

            while(T.hasNext()){
                Territorio Te=T.next();
                if(Te.getPropietario()==Jug){
                    R.add(Te);
                }
            }
            java.util.Random A=new java.util.Random();
            Territorio TR= R.get(A.nextInt(R.size()));
            TR.setCapital(true);
            Carta C=DameCartaCapital(TR);
            C.setPropietario(Jug);
        }   

    }
    //Gestiona el avance del turno en cada una de sus partes
    /**
     *
     */
    public void CompruebaTurno(){
        Object O=1;

        if(getTurnoActual()==Seleccionar_Territorio){

            //Si todos los territorios estan asignados avanza el turno
            if(TodosTerritoriosAsignados()){
                setTurnoActual(Ubicar_Tropas);
                setJugadorTurno(getJugadores().get(0));
                if(getTipoPartida()==1){
                        AsignaCapitales();
                }
            }else{
                //Sino si hay seleccion aleatoria se asignan los territorios automaticamente sino avanza el jugador
                if(getSeleccionAleatoria()){
                    while(TodosTerritoriosAsignados()==false){
                        SiguienteJugador();
                        Territorio Te=DameTerritorioVacio();
                        AsignaTerritorio(Te,getJugadorTurno());
                    }

                    setTurnoActual(Ubicar_Tropas);
                    setJugadorTurno(getJugadores().get(0));
                    if(getTipoPartida()==1){
                        AsignaCapitales();
                    }
                }else{
                    SiguienteJugador();
                   
                }
                
            }

        }else if(getTurnoActual()==Ubicar_Tropas){

            //Si todos los ejercitos estan asignados avanza el turno asignando ejercitos iniciales
            if(TodosEjercitosAsignados()){
                setTurnoActual(Reforzar);
                SumaEjercitosConseguidos();
                setJugadorTurno(getJugadores().get(0));             
            }else{
                //Sino avanza el turno hasta que todos los territorios de los jugadores sean asignados
                SiguienteJugador();
                while(getJugadorTurno().getEjercitos()==0){
                    SiguienteJugador();
                }
                                
            }

        }else  if(getTurnoActual()==Reforzar){
            //Si tiene 5 o mas cartas debe cambiar un set y asi puede avanzar el turno
            if(CartasPoseidas(getJugadorTurno()).size()<5){
                if(getJugadorTurno().getEjercitos()==0){
                    setTurnoActual(Atacar);
                    setDarCarta(false);
                    
                }
            }
            

        }else  if(getTurnoActual()==Atacar){     
                    setTurnoActual(Rearmar);
                    setAtacante(null);
                    setDefensor(null);

        }else  if(getTurnoActual()==Rearmar){
               
                setTurnoActual(Reforzar);
                setTerritorioA(null);
                setTerritorioB(null);

                //Si se ha conseguido conquistar un territorio el jugador coge una carta
                if(getDarCarta()){
                    AsignaCarta(getJugadorTurno());
                }
                //Avanza al siguiente jugador
                SiguienteJugador();
                
                //Si el jugador es el Neutral Avanza al siguiente jugador
                while(getJugadorTurno().getTipo()==2){
                    SiguienteJugador();
                }
                //Evalua el estado del juego indicando si ha terminado o no.
                O=GestionFinPartida(0);

                //Añade los ejercitos inicales correspondientes a territorios y continentes poseidos
                int Ejercitos_Por_Territorios=EjercitosPorTerritoriosPoseidos(getJugadorTurno());
                int Ejercitos_Por_Continentes=EjercitosPorContinentesPoseidos(getJugadorTurno());

                getJugadorTurno().setEjercitos(Ejercitos_Por_Territorios+Ejercitos_Por_Continentes);
               
            
        }
        
        //Avisa a la ventana para que actualice los datos
        setChanged();
        notifyObservers(O);
        
       
        
    }

   
}
